#include "Librerias\CONFIG_PWM_B.h"
#include "Librerias\Config_Interrupcion.h"
#include  "Librerias\config_Input_capture_33f_util.h"
#include  "Librerias\CONFIG_UART_RX1.h"

//INI/VALOR1/VALOR2/VALOR3/*


sbit sw1 at RB0_bit  ;
#define sw2  RB1_bit

unsigned int codigo;
 char texto[50];
float velocidad;
float temperatura;

unsigned int pulso_1,pulso_2,pulso_3,pulso_4;
//pines donde esta los disapro
 sbit in_pulso_1 at  RB4_bit;
  sbit in_pulso_2 at RB5_bit;
 sbit in_pulso_3 at RB6_bit;
 sbit in_pulso_4 at RB7_bit;
 
 //varibales rfecpcion serial
 extern unsigned char Trama_rx1[];
   extern char flag_rx1;
 unsigned char Captura_rx1[50];

float serV1,serV2;

void servo1(float angulo)
{
  OC1RS=3.4722*angulo + 937.5;
}


void servo2(float angulo)
{
  OC2RS=3.4722*angulo + 937.5;
}



void procesa_rx1()
{

  strcpy(Captura_rx1, strtok(trama_rx1, "/"));  //inicia captura de tokens desde el /
  strcpy(Captura_rx1, strtok(0, "/"));  //captura hasta el 1 dato
   serv1=atof(Captura_rx1);
  strcpy(Captura_rx1, strtok(0, "/"));  //captura hasta el 1 dato
  serv2=atof(Captura_rx1);
   
//  strcpy(Captura_rx1, strtok(0, "/"));  //captura hasta el 1 dato
  //serv2=atof(Captura_rx1);

   //carga a los servos

//   sprintf(texto,"ser1=%.1f      serv2=%.1f\r\f",serv1,serv2);
  // UART1_Write_Text(texto);
   servo1(serv1);
   servo2(serv2);

   }


void main()
{

  //CONFIGURA VELOCIDAD DE OPERACION    A 80 MEGAHERT CON CRISTAL DE 4 MEGA

//DEJAMOS N1 Y N2  EN 2

//VELOCIDAD= Cristal*M/(N1*N2)= 4M*80/4=80M

  CLKDIVbits.PLLPRE = 0;      // N1 = 2
  CLKDIVbits.PLLPOST = 0;     // N2 = 2
   PLLFBD=78; // selecciona  M=80;  PLLLFBD es siempre lo deseado menos 2;





//INICIALIZA PINES DIGITALES
 AD1PCFGL = 0xFFFF;        //1=digital  0=analogo

  AD1PCFGLbits.PCFG0=0;// an0 es analogo
  AD1PCFGLbits.PCFG1=0; //an1 analogo
  
  TRISA=0; //todo salida  A
  TRISB=0;  //salida todo B
  TRISB0_bit=1; //ENTRADA PULSADOR1
  TRISB1_bit=1; //ENTRADA
  TRISA0_bit=1; //entrada analoga
  TRISA1_bit=1;
   //REMAPEAMOS SALIDA SERIAL
   PPS_Mapping(13,_OUTPUT,_U1TX);
   PPS_Mapping(14,_INPUT,_U1RX);

   //REMAPEO PWM
   PPS_Mapping(2,_OUTPUT,_OC1);
   PPS_Mapping(3,_OUTPUT,_OC2);
   
   //REMAPEAR LECTURA pwm
    PPS_Mapping(4,_INPUT,_IC1);
   PPS_Mapping(5,_INPUT,_IC2);
   PPS_Mapping(6,_INPUT,_IC7);
   PPS_Mapping(7,_INPUT,_IC8);

   
   
 // UART1_Init(9600); //puerto serial a 9600 baudios
  pwm_init_basico();
 // config_inputcapure(); //LECTURA ANCHO PULSO
  config_uart1_trama(9600);
  
  ADC1_Init_Advanced(_ADC_12bit, _ADC_INTERNAL_REF);  //ADC A 12BITS
  
   habilita();
    servo1(90);
    servo2(-90);
   
   while(1)
   
   {
   /* sprintf(texto,"p1=%u     p2=%u    p3=%u   p4=%u\r\n",pulso_1,pulso_2,pulso_3,pulso_4);
    UART1_Write_Text(texto);
    Delay_ms(1000);
     */
       if (flag_rx1==1)
      {
       procesa_rx1();
     // UART1_Write_Text(Trama_rx1);
      flag_rx1=0;
      memset(Trama_rx1,0,50);// limpia la trama
       U1STAbits.OERR=0; //LIMPIA  errores

      U1RXIF_bit=0;
      U1RXIE_bit=1;


     }
     
     
     
   }

  while(1)
  {

   if (sw1==0)  UART1_Write_Text("LED1=ON/");
   else    UART1_Write_Text("LED1=OFF/");
  
   if (sw2==0)  UART1_Write_Text("LED2=ON/");
   else    UART1_Write_Text("LED2=OFF/");

   codigo=ADC1_Get_Sample(0); //lee el canal 0
   velocidad=codigo*200.0/4095.0;
 
 
   sprintf( texto,"VEL=%.1f/" ,velocidad);
   UART1_Write_Text(texto);
   
  codigo=ADC1_Get_Sample(1);    //lee el canal 1
   temperatura=codigo*500.0/4095.0;
   
   sprintf( texto,"TEM=%.1f/" ,temperatura);
   UART1_Write_Text(texto);

  LATB=~LATB; // porque se usa puerto como salida
  Delay_ms(300);
  
  }
  


}