
_servo1:

;serial.c,31 :: 		void servo1(float angulo)
;serial.c,33 :: 		OC1RS=3.4722*angulo + 937.5;
	MOV	#14470, W0
	MOV	#16478, W1
	MOV.D	W10, W2
	CALL	__Mul_FP
	MOV	#24576, W2
	MOV	#17514, W3
	CALL	__AddSub_FP
	CALL	__Float2Longint
	MOV	WREG, OC1RS
;serial.c,34 :: 		}
L_end_servo1:
	RETURN
; end of _servo1

_servo2:

;serial.c,37 :: 		void servo2(float angulo)
;serial.c,39 :: 		OC2RS=3.4722*angulo + 937.5;
	MOV	#14470, W0
	MOV	#16478, W1
	MOV.D	W10, W2
	CALL	__Mul_FP
	MOV	#24576, W2
	MOV	#17514, W3
	CALL	__AddSub_FP
	CALL	__Float2Longint
	MOV	WREG, OC2RS
;serial.c,40 :: 		}
L_end_servo2:
	RETURN
; end of _servo2

_procesa_rx1:

;serial.c,44 :: 		void procesa_rx1()
;serial.c,47 :: 		strcpy(Captura_rx1, strtok(trama_rx1, "/"));  //inicia captura de tokens desde el /
	PUSH	W10
	PUSH	W11
	MOV	#lo_addr(?lstr1_serial), W11
	MOV	#lo_addr(_Trama_rx1), W10
	CALL	_strtok
	MOV	W0, W11
	MOV	#lo_addr(_Captura_rx1), W10
	CALL	_strcpy
;serial.c,48 :: 		strcpy(Captura_rx1, strtok(0, "/"));  //captura hasta el 1 dato
	MOV	#lo_addr(?lstr2_serial), W11
	CLR	W10
	CALL	_strtok
	MOV	W0, W11
	MOV	#lo_addr(_Captura_rx1), W10
	CALL	_strcpy
;serial.c,49 :: 		serv1=atof(Captura_rx1);
	MOV	#lo_addr(_Captura_rx1), W10
	CALL	_atof
	MOV	W0, _serV1
	MOV	W1, _serV1+2
;serial.c,50 :: 		strcpy(Captura_rx1, strtok(0, "/"));  //captura hasta el 1 dato
	MOV	#lo_addr(?lstr3_serial), W11
	CLR	W10
	CALL	_strtok
	MOV	W0, W11
	MOV	#lo_addr(_Captura_rx1), W10
	CALL	_strcpy
;serial.c,51 :: 		serv2=atof(Captura_rx1);
	MOV	#lo_addr(_Captura_rx1), W10
	CALL	_atof
	MOV	W0, _serV2
	MOV	W1, _serV2+2
;serial.c,60 :: 		servo1(serv1);
	MOV	_serV1, W10
	MOV	_serV1+2, W11
	CALL	_servo1
;serial.c,61 :: 		servo2(serv2);
	MOV	_serV2, W10
	MOV	_serV2+2, W11
	CALL	_servo2
;serial.c,63 :: 		}
L_end_procesa_rx1:
	POP	W11
	POP	W10
	RETURN
; end of _procesa_rx1

_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68

;serial.c,66 :: 		void main()
;serial.c,75 :: 		CLKDIVbits.PLLPRE = 0;      // N1 = 2
	PUSH	W10
	PUSH	W11
	PUSH	W12
	MOV	#lo_addr(CLKDIVbits), W0
	MOV.B	[W0], W1
	MOV.B	#224, W0
	AND.B	W1, W0, W1
	MOV	#lo_addr(CLKDIVbits), W0
	MOV.B	W1, [W0]
;serial.c,76 :: 		CLKDIVbits.PLLPOST = 0;     // N2 = 2
	MOV	#lo_addr(CLKDIVbits), W0
	MOV.B	[W0], W1
	MOV.B	#63, W0
	AND.B	W1, W0, W1
	MOV	#lo_addr(CLKDIVbits), W0
	MOV.B	W1, [W0]
;serial.c,77 :: 		PLLFBD=78; // selecciona  M=80;  PLLLFBD es siempre lo deseado menos 2;
	MOV	#78, W0
	MOV	WREG, PLLFBD
;serial.c,84 :: 		AD1PCFGL = 0xFFFF;        //1=digital  0=analogo
	MOV	#65535, W0
	MOV	WREG, AD1PCFGL
;serial.c,86 :: 		AD1PCFGLbits.PCFG0=0;// an0 es analogo
	BCLR.B	AD1PCFGLbits, #0
;serial.c,87 :: 		AD1PCFGLbits.PCFG1=0; //an1 analogo
	BCLR.B	AD1PCFGLbits, #1
;serial.c,89 :: 		TRISA=0; //todo salida  A
	CLR	TRISA
;serial.c,90 :: 		TRISB=0;  //salida todo B
	CLR	TRISB
;serial.c,91 :: 		TRISB0_bit=1; //ENTRADA PULSADOR1
	BSET	TRISB0_bit, BitPos(TRISB0_bit+0)
;serial.c,92 :: 		TRISB1_bit=1; //ENTRADA
	BSET	TRISB1_bit, BitPos(TRISB1_bit+0)
;serial.c,93 :: 		TRISA0_bit=1; //entrada analoga
	BSET	TRISA0_bit, BitPos(TRISA0_bit+0)
;serial.c,94 :: 		TRISA1_bit=1;
	BSET	TRISA1_bit, BitPos(TRISA1_bit+0)
;serial.c,96 :: 		PPS_Mapping(13,_OUTPUT,_U1TX);
	MOV.B	#3, W12
	CLR	W11
	MOV.B	#13, W10
	CALL	_PPS_Mapping
;serial.c,97 :: 		PPS_Mapping(14,_INPUT,_U1RX);
	MOV.B	#14, W12
	MOV.B	#1, W11
	MOV.B	#14, W10
	CALL	_PPS_Mapping
;serial.c,100 :: 		PPS_Mapping(2,_OUTPUT,_OC1);
	MOV.B	#18, W12
	CLR	W11
	MOV.B	#2, W10
	CALL	_PPS_Mapping
;serial.c,101 :: 		PPS_Mapping(3,_OUTPUT,_OC2);
	MOV.B	#19, W12
	CLR	W11
	MOV.B	#3, W10
	CALL	_PPS_Mapping
;serial.c,104 :: 		PPS_Mapping(4,_INPUT,_IC1);
	MOV.B	#4, W12
	MOV.B	#1, W11
	MOV.B	#4, W10
	CALL	_PPS_Mapping
;serial.c,105 :: 		PPS_Mapping(5,_INPUT,_IC2);
	MOV.B	#5, W12
	MOV.B	#1, W11
	MOV.B	#5, W10
	CALL	_PPS_Mapping
;serial.c,106 :: 		PPS_Mapping(6,_INPUT,_IC7);
	MOV.B	#6, W12
	MOV.B	#1, W11
	MOV.B	#6, W10
	CALL	_PPS_Mapping
;serial.c,107 :: 		PPS_Mapping(7,_INPUT,_IC8);
	MOV.B	#7, W12
	MOV.B	#1, W11
	MOV.B	#7, W10
	CALL	_PPS_Mapping
;serial.c,112 :: 		pwm_init_basico();
	CALL	_pwm_init_basico
;serial.c,114 :: 		config_uart1_trama(9600);
	MOV	#9600, W10
	CALL	_config_uart1_trama
;serial.c,116 :: 		ADC1_Init_Advanced(_ADC_12bit, _ADC_INTERNAL_REF);  //ADC A 12BITS
	CLR	W11
	MOV	#1, W10
	CALL	_ADC1_Init_Advanced
;serial.c,118 :: 		habilita();
	CALL	_habilita
;serial.c,119 :: 		servo1(90);
	MOV	#0, W10
	MOV	#17076, W11
	CALL	_servo1
;serial.c,120 :: 		servo2(-90);
	MOV	#0, W10
	MOV	#49844, W11
	CALL	_servo2
;serial.c,122 :: 		while(1)
L_main0:
;serial.c,129 :: 		if (flag_rx1==1)
	MOV	#lo_addr(_flag_rx1), W0
	MOV.B	[W0], W0
	CP.B	W0, #1
	BRA Z	L__main15
	GOTO	L_main2
L__main15:
;serial.c,131 :: 		procesa_rx1();
	CALL	_procesa_rx1
;serial.c,133 :: 		flag_rx1=0;
	MOV	#lo_addr(_flag_rx1), W1
	CLR	W0
	MOV.B	W0, [W1]
;serial.c,134 :: 		memset(Trama_rx1,0,50);// limpia la trama
	MOV	#50, W12
	CLR	W11
	MOV	#lo_addr(_Trama_rx1), W10
	CALL	_memset
;serial.c,135 :: 		U1STAbits.OERR=0; //LIMPIA  errores
	BCLR.B	U1STAbits, #1
;serial.c,137 :: 		U1RXIF_bit=0;
	BCLR	U1RXIF_bit, BitPos(U1RXIF_bit+0)
;serial.c,138 :: 		U1RXIE_bit=1;
	BSET	U1RXIE_bit, BitPos(U1RXIE_bit+0)
;serial.c,141 :: 		}
L_main2:
;serial.c,145 :: 		}
	GOTO	L_main0
;serial.c,176 :: 		}
L_end_main:
	POP	W12
	POP	W11
	POP	W10
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main
